[oe-commits] org.oe.dev initscripts: adaptions necessary for use with nylon on 4G access cube.

MartinDietze commit openembedded-commits at lists.openembedded.org
Fri Sep 8 13:07:22 UTC 2006


initscripts: adaptions necessary for use with nylon on 4G access cube.
* mtx-2 hardware added
* the mount command for the local file systems did not work with tmpfs
* checkroot did not remount / rw

Author: MartinDietze at openembedded.org
Branch: org.openembedded.dev
Revision: 53431a34140f1d457a689fc08f239183d57e7819
ViewMTN: http://monotone.openembedded.org/revision.psp?id=53431a34140f1d457a689fc08f239183d57e7819
Files:
1
packages/initscripts/initscripts-1.0/mtx-1
packages/initscripts/initscripts-1.0/mtx-2
packages/initscripts/initscripts-1.0/mtx-1/checkroot.sh
packages/initscripts/initscripts-1.0/mtx-1/mountall.sh
packages/initscripts/initscripts-1.0/mtx-2/checkroot.sh
packages/initscripts/initscripts-1.0/mtx-2/mountall.sh
mtn:execute
true
Diffs:

#
# mt diff -r59f5686356b4aa084ebf13254091b40864f7d4fd -r53431a34140f1d457a689fc08f239183d57e7819
#
# 
# 
# add_dir "packages/initscripts/initscripts-1.0/mtx-1"
# 
# add_dir "packages/initscripts/initscripts-1.0/mtx-2"
# 
# add_file "packages/initscripts/initscripts-1.0/mtx-1/checkroot.sh"
#  content [d357577158a6197c067b2d4c040a67a9dc6065ea]
# 
# add_file "packages/initscripts/initscripts-1.0/mtx-1/mountall.sh"
#  content [086bebf315e3f241bcfd744dcfd1c8f121a4aed8]
# 
# add_file "packages/initscripts/initscripts-1.0/mtx-2/checkroot.sh"
#  content [d357577158a6197c067b2d4c040a67a9dc6065ea]
# 
# add_file "packages/initscripts/initscripts-1.0/mtx-2/mountall.sh"
#  content [086bebf315e3f241bcfd744dcfd1c8f121a4aed8]
# 
#   set "packages/initscripts/initscripts-1.0/mtx-1/checkroot.sh"
#  attr "mtn:execute"
# value "true"
# 
#   set "packages/initscripts/initscripts-1.0/mtx-1/mountall.sh"
#  attr "mtn:execute"
# value "true"
# 
#   set "packages/initscripts/initscripts-1.0/mtx-2/checkroot.sh"
#  attr "mtn:execute"
# value "true"
# 
#   set "packages/initscripts/initscripts-1.0/mtx-2/mountall.sh"
#  attr "mtn:execute"
# value "true"
# 
============================================================
--- packages/initscripts/initscripts-1.0/mtx-1/checkroot.sh	d357577158a6197c067b2d4c040a67a9dc6065ea
+++ packages/initscripts/initscripts-1.0/mtx-1/checkroot.sh	d357577158a6197c067b2d4c040a67a9dc6065ea
@@ -0,0 +1,167 @@
+#
+# checkroot.sh	Check to root filesystem.
+#
+# Version:	@(#)checkroot.sh  2.84  25-Jan-2002  miquels at cistron.nl
+#
+
+. /etc/default/rcS
+
+#
+# Set SULOGIN in /etc/default/rcS to yes if you want a sulogin to be spawned
+# from this script *before anything else* with a timeout, like SCO does.
+#
+test "$SULOGIN" = yes && sulogin -t 30 $CONSOLE
+
+#
+# Ensure that bdflush (update) is running before any major I/O is
+# performed (the following fsck is a good example of such activity :).
+#
+test -x /sbin/update && update
+
+#
+# Read /etc/fstab.
+#
+exec 9>&0 </etc/fstab
+rootmode=rw
+rootopts=rw
+rootcheck=no
+swap_on_md=no
+devfs=
+while read fs mnt type opts dump pass junk
+do
+	case "$fs" in
+		""|\#*)
+			continue;
+			;;
+		/dev/md*)
+			# Swap on md device.
+			test "$type" = swap && swap_on_md=yes
+			;;
+		/dev/*)
+			;;
+		*)
+			# Might be a swapfile.
+			test "$type" = swap && swap_on_md=yes
+			;;
+	esac
+	test "$type" = devfs && devfs="$fs"
+	test "$mnt" != / && continue
+	rootopts="$opts"
+	test "$pass" = 0 -o "$pass" = "" && rootcheck=no
+	case "$opts" in
+		ro|ro,*|*,ro|*,ro,*)
+			rootmode=ro
+			;;
+	esac
+done
+exec 0>&9 9>&-
+
+#
+# Activate the swap device(s) in /etc/fstab. This needs to be done
+# before fsck, since fsck can be quite memory-hungry.
+#
+doswap=no
+test -d /proc/1 || mount -n /proc
+case "`uname -r`" in
+	2.[0123].*)
+		if test $swap_on_md = yes && grep -qs resync /proc/mdstat
+		then
+			test "$VERBOSE" != no && echo "Not activating swap - RAID array resyncing"
+		else
+			doswap=yes
+		fi
+		;;
+	*)
+		doswap=yes
+		;;
+esac
+if test $doswap = yes
+then
+	test "$VERBOSE" != no && echo "Activating swap"
+	swapon -a 2> /dev/null
+fi
+
+#
+# Check the root filesystem.
+#
+if test -f /fastboot || test $rootcheck = no
+then
+  test $rootcheck = yes && echo "Fast boot, no filesystem check"
+else
+  #
+  # Ensure that root is quiescent and read-only before fsck'ing.
+  #
+  mount -n -o remount,ro /
+  if test $? = 0
+  then
+    if test -f /forcefsck
+    then
+	force="-f"
+    else
+	force=""
+    fi
+    if test "$FSCKFIX" = yes
+    then
+	fix="-y"
+    else
+	fix="-a"
+    fi
+    spinner="-C"
+    case "$TERM" in
+        dumb|network|unknown|"") spinner="" ;;
+    esac
+    test `uname -m` = s390 && spinner="" # This should go away
+    test "$VERBOSE" != no && echo "Checking root filesystem..."
+    fsck $spinner $force $fix /
+    #
+    # If there was a failure, drop into single-user mode.
+    #
+    # NOTE: "failure" is defined as exiting with a return code of
+    # 2 or larger.  A return code of 1 indicates that filesystem
+    # errors were corrected but that the boot may proceed.
+    #
+    if test "$?" -gt 1
+    then
+      # Surprise! Re-directing from a HERE document (as in
+      # "cat << EOF") won't work, because the root is read-only.
+      echo
+      echo "fsck failed.  Please repair manually and reboot.  Please note"
+      echo "that the root filesystem is currently mounted read-only.  To"
+      echo "remount it read-write:"
+      echo
+      echo "   # mount -n -o remount,rw /"
+      echo
+      echo "CONTROL-D will exit from this shell and REBOOT the system."
+      echo
+      # Start a single user shell on the console
+      /sbin/sulogin $CONSOLE
+      reboot -f
+    fi
+  else
+    echo "*** ERROR!  Cannot fsck root fs because it is not mounted read-only!"
+    echo
+  fi
+fi
+
+#
+#	If the root filesystem was not marked as read-only in /etc/fstab,
+#	remount the rootfs rw but do not try to change mtab because it
+#	is on a ro fs until the remount succeeded. Then clean up old mtabs
+#	and finally write the new mtab.
+#	This part is only needed if the rootfs was mounted ro.
+#
+echo "Remounting root file system..."
+mount -n -o remount,$rootmode /
+if test "$rootmode" = rw
+then
+	if test ! -L /etc/mtab
+	then
+		rm -f /etc/mtab~ /etc/nologin
+		: > /etc/mtab
+	fi
+	mount -f -o remount /
+	mount -f /proc
+	test "$devfs" && grep -q '^devfs /dev' /proc/mounts && mount -f "$devfs"
+fi
+
+: exit 0
============================================================
--- packages/initscripts/initscripts-1.0/mtx-1/mountall.sh	086bebf315e3f241bcfd744dcfd1c8f121a4aed8
+++ packages/initscripts/initscripts-1.0/mtx-1/mountall.sh	086bebf315e3f241bcfd744dcfd1c8f121a4aed8
@@ -0,0 +1,46 @@
+#
+# mountall.sh	Mount all filesystems.
+#
+# Version:	@(#)mountall.sh  2.83-2  01-Nov-2001  miquels at cistron.nl
+#
+. /etc/default/rcS
+
+#
+# Mount local filesystems in /etc/fstab. For some reason, people
+# might want to mount "proc" several times, and mount -v complains
+# about this. So we mount "proc" filesystems without -v.
+#
+test "$VERBOSE" != no && echo "Mounting local filesystems..."
+mount -a 2>/dev/null
+#t nonfs,nosmbfs,noncpfs 2>/dev/null
+
+#
+# We might have mounted something over /dev, see if /dev/initctl is there.
+#
+if test ! -p /dev/initctl
+then
+	rm -f /dev/initctl
+	mknod -m 600 /dev/initctl p
+fi
+kill -USR1 1
+
+#
+# Execute swapon command again, in case we want to swap to
+# a file on a now mounted filesystem.
+#
+doswap=yes
+case "`uname -r`" in
+	2.[0123].*)
+		if grep -qs resync /proc/mdstat
+		then
+			doswap=no
+		fi
+		;;
+esac
+if test $doswap = yes
+then
+	swapon -a 2> /dev/null
+fi
+
+: exit 0
+
============================================================
--- packages/initscripts/initscripts-1.0/mtx-2/checkroot.sh	d357577158a6197c067b2d4c040a67a9dc6065ea
+++ packages/initscripts/initscripts-1.0/mtx-2/checkroot.sh	d357577158a6197c067b2d4c040a67a9dc6065ea
@@ -0,0 +1,167 @@
+#
+# checkroot.sh	Check to root filesystem.
+#
+# Version:	@(#)checkroot.sh  2.84  25-Jan-2002  miquels at cistron.nl
+#
+
+. /etc/default/rcS
+
+#
+# Set SULOGIN in /etc/default/rcS to yes if you want a sulogin to be spawned
+# from this script *before anything else* with a timeout, like SCO does.
+#
+test "$SULOGIN" = yes && sulogin -t 30 $CONSOLE
+
+#
+# Ensure that bdflush (update) is running before any major I/O is
+# performed (the following fsck is a good example of such activity :).
+#
+test -x /sbin/update && update
+
+#
+# Read /etc/fstab.
+#
+exec 9>&0 </etc/fstab
+rootmode=rw
+rootopts=rw
+rootcheck=no
+swap_on_md=no
+devfs=
+while read fs mnt type opts dump pass junk
+do
+	case "$fs" in
+		""|\#*)
+			continue;
+			;;
+		/dev/md*)
+			# Swap on md device.
+			test "$type" = swap && swap_on_md=yes
+			;;
+		/dev/*)
+			;;
+		*)
+			# Might be a swapfile.
+			test "$type" = swap && swap_on_md=yes
+			;;
+	esac
+	test "$type" = devfs && devfs="$fs"
+	test "$mnt" != / && continue
+	rootopts="$opts"
+	test "$pass" = 0 -o "$pass" = "" && rootcheck=no
+	case "$opts" in
+		ro|ro,*|*,ro|*,ro,*)
+			rootmode=ro
+			;;
+	esac
+done
+exec 0>&9 9>&-
+
+#
+# Activate the swap device(s) in /etc/fstab. This needs to be done
+# before fsck, since fsck can be quite memory-hungry.
+#
+doswap=no
+test -d /proc/1 || mount -n /proc
+case "`uname -r`" in
+	2.[0123].*)
+		if test $swap_on_md = yes && grep -qs resync /proc/mdstat
+		then
+			test "$VERBOSE" != no && echo "Not activating swap - RAID array resyncing"
+		else
+			doswap=yes
+		fi
+		;;
+	*)
+		doswap=yes
+		;;
+esac
+if test $doswap = yes
+then
+	test "$VERBOSE" != no && echo "Activating swap"
+	swapon -a 2> /dev/null
+fi
+
+#
+# Check the root filesystem.
+#
+if test -f /fastboot || test $rootcheck = no
+then
+  test $rootcheck = yes && echo "Fast boot, no filesystem check"
+else
+  #
+  # Ensure that root is quiescent and read-only before fsck'ing.
+  #
+  mount -n -o remount,ro /
+  if test $? = 0
+  then
+    if test -f /forcefsck
+    then
+	force="-f"
+    else
+	force=""
+    fi
+    if test "$FSCKFIX" = yes
+    then
+	fix="-y"
+    else
+	fix="-a"
+    fi
+    spinner="-C"
+    case "$TERM" in
+        dumb|network|unknown|"") spinner="" ;;
+    esac
+    test `uname -m` = s390 && spinner="" # This should go away
+    test "$VERBOSE" != no && echo "Checking root filesystem..."
+    fsck $spinner $force $fix /
+    #
+    # If there was a failure, drop into single-user mode.
+    #
+    # NOTE: "failure" is defined as exiting with a return code of
+    # 2 or larger.  A return code of 1 indicates that filesystem
+    # errors were corrected but that the boot may proceed.
+    #
+    if test "$?" -gt 1
+    then
+      # Surprise! Re-directing from a HERE document (as in
+      # "cat << EOF") won't work, because the root is read-only.
+      echo
+      echo "fsck failed.  Please repair manually and reboot.  Please note"
+      echo "that the root filesystem is currently mounted read-only.  To"
+      echo "remount it read-write:"
+      echo
+      echo "   # mount -n -o remount,rw /"
+      echo
+      echo "CONTROL-D will exit from this shell and REBOOT the system."
+      echo
+      # Start a single user shell on the console
+      /sbin/sulogin $CONSOLE
+      reboot -f
+    fi
+  else
+    echo "*** ERROR!  Cannot fsck root fs because it is not mounted read-only!"
+    echo
+  fi
+fi
+
+#
+#	If the root filesystem was not marked as read-only in /etc/fstab,
+#	remount the rootfs rw but do not try to change mtab because it
+#	is on a ro fs until the remount succeeded. Then clean up old mtabs
+#	and finally write the new mtab.
+#	This part is only needed if the rootfs was mounted ro.
+#
+echo "Remounting root file system..."
+mount -n -o remount,$rootmode /
+if test "$rootmode" = rw
+then
+	if test ! -L /etc/mtab
+	then
+		rm -f /etc/mtab~ /etc/nologin
+		: > /etc/mtab
+	fi
+	mount -f -o remount /
+	mount -f /proc
+	test "$devfs" && grep -q '^devfs /dev' /proc/mounts && mount -f "$devfs"
+fi
+
+: exit 0
============================================================
--- packages/initscripts/initscripts-1.0/mtx-2/mountall.sh	086bebf315e3f241bcfd744dcfd1c8f121a4aed8
+++ packages/initscripts/initscripts-1.0/mtx-2/mountall.sh	086bebf315e3f241bcfd744dcfd1c8f121a4aed8
@@ -0,0 +1,46 @@
+#
+# mountall.sh	Mount all filesystems.
+#
+# Version:	@(#)mountall.sh  2.83-2  01-Nov-2001  miquels at cistron.nl
+#
+. /etc/default/rcS
+
+#
+# Mount local filesystems in /etc/fstab. For some reason, people
+# might want to mount "proc" several times, and mount -v complains
+# about this. So we mount "proc" filesystems without -v.
+#
+test "$VERBOSE" != no && echo "Mounting local filesystems..."
+mount -a 2>/dev/null
+#t nonfs,nosmbfs,noncpfs 2>/dev/null
+
+#
+# We might have mounted something over /dev, see if /dev/initctl is there.
+#
+if test ! -p /dev/initctl
+then
+	rm -f /dev/initctl
+	mknod -m 600 /dev/initctl p
+fi
+kill -USR1 1
+
+#
+# Execute swapon command again, in case we want to swap to
+# a file on a now mounted filesystem.
+#
+doswap=yes
+case "`uname -r`" in
+	2.[0123].*)
+		if grep -qs resync /proc/mdstat
+		then
+			doswap=no
+		fi
+		;;
+esac
+if test $doswap = yes
+then
+	swapon -a 2> /dev/null
+fi
+
+: exit 0
+






More information about the Openembedded-commits mailing list